Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 203886 - [TRACKER] dev-lang/ocaml and ocaml related packages: make ocamlopt (aka native code compiler) optional and controled via an useflag
Summary: [TRACKER] dev-lang/ocaml and ocaml related packages: make ocamlopt (aka nativ...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: High enhancement (vote)
Assignee: Gentoo Team for the ML programming language family
URL:
Whiteboard:
Keywords: Tracker
Depends on: 203887 204110 204812 204819
Blocks: 179895
  Show dependency tree
 
Reported: 2007-12-31 14:27 UTC by Alexis Ballier
Modified: 2017-01-19 18:47 UTC (History)
1 user (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Alexis Ballier gentoo-dev 2007-12-31 14:27:03 UTC
As jer suggested in bug #179895 it is a good idea to have them optional rather than having them always built and having arch specific code in ocaml ebuild for arches that do not support it.

However this raises several issues:
- ebuilds/packages that assume ocamlopt is present have to be fixed
- some of those packages can still build without native code support using ocamlc, or ocamlc -custom. The latter triggers some other issues: it embeds ocamlrun (the interpreter) and the bytecode, if you strip them, you lose the bytecode.
- For some weird reasons I dont fully understand (yet?) running debugedit on such files also remove the bytecode.
Comment 1 Alexis Ballier gentoo-dev 2008-01-03 18:07:40 UTC
okey I've made ocamlopt an useflag on >=dev-lang/ocaml-3.10
as you can see I've not yet finished to check every pacakge, but most of them should be sane.

@ppc64: as previously ocamlopt was disabled in ocaml ebuild by some arch specific code, please use.mask ocamlopt useflag on 64bits userland profiles to keep the same behavior.
Moreover, from my checks all dev-ml/findlib versions failed on ppc64, I've fixed 1.2.1 to have the ocamlopt useflag; as stable version should be broken, if you want to have 1.2.1 straight stable that's your call; I'll file a stabilisation bug in some time anyway.
Comment 2 Alexis Ballier gentoo-dev 2008-01-06 20:55:18 UTC
ping ppc64: on my g5 I cant build neither dev-ml/findlib nor dev-ml/facile...
I dunno how you managed to build native code support for dev-ml/facile, and kdeedu/kalzium need native code support for facile to build the solver, so if you plan to disable ocamlopt support, you'll also have to mask the solver useflag for those kde packages.
You seem to have tested it since facile was keyworded recently, but as far as I know, ocaml does *not* support powerpc64 elf target...
Comment 3 Markus Rothe (RETIRED) gentoo-dev 2008-01-07 10:27:46 UTC
who the hell marked those packages stable? (it was me... seems like I fscked it up.)

gimme some time to look into it. I wouldn't mind if you want to fix it yourself, as I'm not using ocaml personaly.
Comment 4 Jeroen Roovers (RETIRED) gentoo-dev 2008-01-07 11:52:13 UTC
dev-libs/gmetadom has IUSE=ocaml and fails when ocamlopt is missing, even though configure specially checks for it.
Comment 5 Alexis Ballier gentoo-dev 2008-01-07 20:59:47 UTC
(In reply to comment #4)
> dev-libs/gmetadom has IUSE=ocaml and fails when ocamlopt is missing, even
> though configure specially checks for it.

hmmm seems like I had checked reverse rdepends but not reverse build depends...


@markus: it *should* be fixed now, it just needs ocamlopt use masked + the kde solver also use masked (for the reverse deps of dev-ml/facile) and dev-ml/findlib 1.2.1 going stable (because its the one having ocamlopt optional)
Comment 6 Markus Rothe (RETIRED) gentoo-dev 2008-01-08 07:02:24 UTC
(In reply to comment #5)
> @markus: it *should* be fixed now, it just needs ocamlopt use masked + the kde
> solver also use masked (for the reverse deps of dev-ml/facile) and
> dev-ml/findlib 1.2.1 going stable (because its the one having ocamlopt
> optional)
> 

thanks a lot!
Comment 7 Tom Gall (RETIRED) gentoo-dev 2008-01-17 18:23:19 UTC
so for ppc64 we've used masked ocamlopt for now. It'll take some effort to support ocaml...  perhaps someday .. but not quite yet. 

Going to drop us from this bug .. and we'll reopen something related to ocaml when I step up and fix or upstream addresses.  Hopefully this sounds acceptable.

Regards,

Tom
Comment 8 Alexis Ballier gentoo-dev 2008-03-01 23:13:05 UTC
we can close this one now I think